package com.dsoft.RNAndroidChart;

import android.graphics.Color;
import android.content.Context;
import android.graphics.Canvas;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;
import android.widget.Button;

import com.github.mikephil.charting.components.MarkerView;
import com.github.mikephil.charting.data.CandleEntry;
import com.github.mikephil.charting.data.Entry;
import com.github.mikephil.charting.highlight.Highlight;
import com.github.mikephil.charting.utils.Utils;

import com.facebook.react.bridge.ReadableArray;
import android.util.Log;

/**
 * Created by admin on 2017/9/19.
 */

public class CustomMarkerView extends MarkerView {

    private TextView tvContent;
	private Button tvButton;
	private ReadableArray initialValues = null;

    public CustomMarkerView(Context context, int layoutResource) {
        super(context,layoutResource);
        tvContent = (TextView) findViewById(R.id.content_txt);
		tvButton  = (Button) findViewById(R.id.content_btn);
    }
	
	public void setTipBgColor(String tipBgColor){
		tvButton.getBackground().setTint(Color.parseColor(tipBgColor));
	}
	
	public void setTipTextColor(String tipTextColor){
		tvContent.setTextColor(Color.parseColor(tipTextColor));
	}
	
	public void setTipTextSize(float testSize){
		Log.e("tipTextSize",""+testSize);
		tvContent.setTextSize(testSize);
	}

	public void setInitialValues( ReadableArray initial ){
		if(initial != null) this.initialValues = initial;
	}
	
    @Override
    public void refreshContent(Entry e, Highlight highlight) {
//Log.e("refreshContent1", "e:("+e.getXIndex()+")");
//if( initialValues!=null ) Log.e("refreshContent2","return :("+initialValues.getString(e.getXIndex())+")");
        if (e instanceof CandleEntry) {
            CandleEntry ce = (CandleEntry) e;
            tvContent.setText("" + Utils.formatNumber(ce.getHigh(), 0, true));
        } else {
			if( initialValues!=null ) tvContent.setText("" + initialValues.getString(e.getXIndex()) );
            else tvContent.setText("" + e.getVal());
        }
        //super.refreshContent(e, highlight);
    }

    @Override
    public int getXOffset(float var1){
        return -(getWidth() / 2);
    }
    @Override
    public int getYOffset(float var1){
        return  -getHeight();
    }
}
